#
# Conditional build:
%bcond_without	ocaml_opt	# skip building native optimized binaries (bytecode is always built)

# not yet available on x32 (ocaml 4.02.1), update when upstream will support it
%ifnarch %{ix86} %{x8664} arm aarch64 ppc sparc sparcv9
%undefine	with_ocaml_opt
%endif

Summary:	Objective Caml Preprocessor
Summary(pl.UTF-8):	Preprocesor OCamla
Name:		camlp5
Version:	6.15
Release:	1
License:	distributable
Group:		Development/Languages
Source0:	http://camlp5.gforge.inria.fr/distrib/src/%{name}-%{version}.tgz
# Source0-md5:	ad79f4b4384109fbb92b1b3bcb105224
Source1:	http://camlp5.gforge.inria.fr/doc/pdf/%{name}-6.00.pdf
# Source1-md5:	b241eabfeb48f22b0fbd3e497198a76a
URL:		http://caml.inria.fr/
BuildRequires:	db-devel >= 4.1
BuildRequires:	ocaml
%requires_eq	ocaml-runtime
Requires:	%{name} = %{epoch}:%{version}-%{release}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Camlp5 is a Pre-Processor-Pretty-Printer for Objective Caml. It offers
tools for syntax (grammars) and the ability to modify the concrete
syntax of the language (quotations, syntax extensions).

Camlp5 can parse normal Ocaml concrete syntax or any other
user-definable syntax. As an example, an alternative syntax is
provided, named revised, because it tries to fix some small problems
of the normal syntax.

Camlp5 can pretty print the normal Ocaml concrete syntax or the
revised one. It is therefore always possible to have a version of your
sources compilable by the Objective Caml compiler without
preprocessing.

%description -l pl.UTF-8
Camlp5 jest preprocesorem OCamla. Oferuje narzędzia do manipulowania
składnią (gramatyki) oraz możliwość modyfikowania oryginalnej składni
języka (cytowania, rozszerzenia).

Camlp5 może sparsować oryginalną składnię Ocamla lub dowolną inną
definiowalną przez użytkownika. Jako przykład podana jest alternatywna
składnia (revised syntax), która próbuje poprawić drobne problemy
występujące w składni oryginalnej.

Camlp5 umie ładnie formatować źródła zarówno w oryginalnej jak i
poprawionej składni OCamla. Potrafi także tłumaczyć programy z jednej
składni na drugą.

%package doc-html
Summary:	Objective Caml Preprocessor - HTML documentation 
Summary(pl.UTF-8):	Preprocesor OCamla - dokumentacja HTML 
Group:		Development/Languages

%description doc-html
Objective Caml Preprocessor - HTML documentation.

%description doc-html -l pl.UTF-8
Preprocesor OCamla - dokumentacja HTML.

%prep
%setup -q

cp %{SOURCE1} doc/camlp4.pdf

%build 
./configure \
	-bindir %{_bindir} \
	-libdir %{_libdir}/ocaml \
	-mandir %{_mandir}/man1 \
	-transitional

%{__make} -j1 world%{?with_ocaml_opt:.opt}
%{__make} -j1 -C doc/htmlp

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	BINDIR=$RPM_BUILD_ROOT%{_bindir} \
	LIBDIR=$RPM_BUILD_ROOT%{_libdir}/ocaml \
	MANDIR=$RPM_BUILD_ROOT%{_mandir}

# broken build system
for f in mkcamlp5.1 ocpp5.1 camlp5o.1 camlp5r.1 camlp5sch.1 \
	%{?with_ocaml_opt:camlp5o.opt.1 camlp5r.opt.1 mkcamlp5.opt.1} ; do
	%{__rm} $RPM_BUILD_ROOT%{_mandir}/man1/$f
	echo '.so camlp5.1' >$RPM_BUILD_ROOT%{_mandir}/man1/$f
done

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc CHANGES DEVEL ICHANGES MODE README UPGRADING doc/camlp4.pdf
%attr(755,root,root) %{_bindir}/camlp5*
%attr(755,root,root) %{_bindir}/mkcamlp5*
%attr(755,root,root) %{_bindir}/ocpp5
%{_libdir}/ocaml/%{name}
%{_mandir}/man1/camlp5*.1*
%{_mandir}/man1/mkcamlp5*.1*
%{_mandir}/man1/ocpp5.1*

%files doc-html
%defattr(644,root,root,755)
%doc doc/html/*
%changelog
* Mon Mar 21 2016 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/camlp5.git;a=log;h=master

* Mon Mar 21 2016 Jan Rękorajski <baggins@pld-linux.org> 0576448
- updated to 6.15

* Mon Jul 20 2015 Jakub Bogusz <qboosh@pld-linux.org> bfe7d50
- added ocaml_opt bcond

* Mon Jul 20 2015 Jakub Bogusz <qboosh@pld-linux.org> 1aebc93
- replaced ocaml-4.02.2 patch by real ocaml 4.02.2 support from camlp5 git
- updated descriptions (camlp5 not camlp4)
- release 2 (ocaml rebuild)

* Thu Jul 09 2015 Jan Rękorajski <baggins@pld-linux.org> 07f7ea5
- one more ocaml 4.02.2 fix

* Thu Jul 09 2015 Jan Rękorajski <baggins@pld-linux.org> 6831d50
- fix building with ocaml 4.02.2

* Sun Nov 16 2014 Jan Rękorajski <baggins@pld-linux.org> 62e5c23
- up to 6.12

* Mon Sep 26 2011 Jan Rękorajski <baggins@pld-linux.org> 82a0b07
- updated to 6.02.3

* Thu Apr 07 2011 Jan Rękorajski <baggins@pld-linux.org> f0df40a
- rel 2
- added official patches

* Wed Apr 06 2011 Jan Rękorajski <baggins@pld-linux.org> f95747a
- 6.02.2

* Mon Feb 16 2009 Jan Rękorajski <baggins@pld-linux.org> fd60286
- added docs to main package

* Mon Feb 16 2009 Jan Rękorajski <baggins@pld-linux.org> 6b574e5
- no need for external html tgz
- cleaned build/install/files

* Mon Feb 16 2009 Jan Rękorajski <baggins@pld-linux.org> 170a6c1
- initial revision

